#include "stdafx.h"
#include "bangs.h"
#include "main.h"
#include "group.h"
#include "utils.h"

typedef struct BangItem {
	char szName[25];
	BangCommand *pCommand;
} BangItem;

#define BANGS_NUM		28
BangItem g_Bangs[BANGS_NUM] =
{
	{	"Show",							bangShow	},
	{	"Hide",							bangHide	},
	{	"Toggle",						bangToggle	},
	{	"Reset",						bangReset	},
	{	"SortByName",					bangSortByName	},
	{	"SortBySize",					bangSortBySize	},
	{	"SortByType",					bangSortByType	},
	{	"SortByDate",					bangSortByDate	},
	{	"SetTextColor",					bangSetTextColor},
	{	"SetTextBkColor",				bangSetTextBkColor},
	{	"SetBackground",				bangSetBackground},
	{	"SetBackgroundColor",			bangSetBackgroundColor},
	//{	"Hook",							bangHook	},
	{	"ToggleExplorerDesktop",		bangToggleExplorerDesktop	},
	{	"ExplorerDesktop",				bangExplorerDesktop	},
	{	"HotTracking",					bangHotTracking	},
	{	"HotTrackingTime",				bangHotTrackingTime	},
	{	"ConfirmFileDelete",			bangConfirmFileDelete },
	{	"DontUseRecycleBin",			bangDontUseReycleBin },
	{	"NoConnectedFiles",				bangNoConnectedFiles },
	{	"SimpleProgress",				bangSimpleProgress },
	{	"SnapToGrid",					bangSnapToGrid },
	{	"VirtualFileDelete",			bangVirtualFileDelete },
	{	"UseDelete",					bangUseDelete },
	{	"UseRename",					bangUseRename },
	/*{	"ShowMyComputer",				bangShowMyComputer },
	{	"ShowMyNetworkPlaces",			bangShowMyNetworkPlaces },
	{	"ShowInternetExplorer",			bangShowInternetExplorer },
	{	"ShowMyDocuments",				bangShowMyDocuments },
	{	"ShowRecycleBin",				bangShowRecycleBin },*/
	{	"PasteFiles",					bangPasteFiles },
	{	"ChangeDir",					bangChangeDir },
	{	"SetViewMode",					bangSetViewMode },
	{	"InlineBrowsing",				bangInlineBrowsing }
};


void RegisterBangs() {
	for (int i = 0; i < BANGS_NUM; i++) {
		char szBangName[MAX_BANGCOMMAND];;
		StringCchPrintf(szBangName, MAX_BANGCOMMAND, "!%s%s", g_szAppName, g_Bangs[i].szName);
		AddBangCommand(szBangName, g_Bangs[i].pCommand);
	}
}

void UnregisterBangs() {
	for (int i = 0; i < BANGS_NUM; i++) {
		char szBangName[MAX_BANGCOMMAND];;
		StringCchPrintf(szBangName, MAX_BANGCOMMAND, "!%s%s", g_szAppName, g_Bangs[i].szName);
		RemoveBangCommand(szBangName);
	}
}


////////////////////////////////////////////////////////////////////////////
//
// Diagnostic message for !bangs
//
void BangFailed(const char *szBangName, const char *szGroup) {
	utils::ErrorBoxPrint("Icon group with name \"%s\" not found\n!%s%s bang failed", szGroup, g_szAppName, szBangName);
}


void bangShow	(HWND caller, LPCSTR szArgs) {
	CGroup *pGroup = GetGroupByName(szArgs);
	if (pGroup)
		pGroup->Show();
	else
		BangFailed("Show", szArgs);
}

void bangHide	(HWND caller, LPCSTR szArgs) {
	CGroup *pGroup = GetGroupByName(szArgs);
	if (pGroup)
		pGroup->Hide();
	else
		BangFailed("Hide", szArgs);
}

void bangToggle	(HWND caller, LPCSTR szArgs) {
	CGroup *pGroup = GetGroupByName(szArgs);
	if (pGroup)
		pGroup->Toggle();
	else
		BangFailed("Toggle", szArgs);
}

void bangReset	(HWND caller, LPCSTR szArgs)
{
	char token[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[1];
	tokens[0] = token;
	LCTokenize(szArgs, tokens, 1, szExtra);
	CGroup *pGroup = GetGroupByName(tokens[0]);
	if (!pGroup)
	{
		BangFailed("Reset", token);
		return;
	}
	pGroup->Reset(szExtra);
}

void bangSortByName	(HWND caller, LPCSTR szArgs)
{
	CGroup *pGroup = GetGroupByName(szArgs);
	if (pGroup)
		pGroup->SortByName();
	else
		BangFailed("SortByName", szArgs);
}

void bangSortBySize	(HWND caller, LPCSTR szArgs)
{
	CGroup *pGroup = GetGroupByName(szArgs);
	if (pGroup)
		pGroup->SortBySize();
	else
		BangFailed("SortBySize", szArgs);
}

void bangSortByType	(HWND caller, LPCSTR szArgs)
{
	CGroup *pGroup = GetGroupByName(szArgs);
	if (pGroup)
		pGroup->SortByType();
	else
		BangFailed("SortByType", szArgs);
}

void bangSortByDate	(HWND caller, LPCSTR szArgs)
{
	CGroup *pGroup = GetGroupByName(szArgs);
	if (pGroup)
		pGroup->SortByDate();
	else
		BangFailed("SortByDate", szArgs);
}

void bangSetTextColor	(HWND caller, LPCSTR szArgs)
{
	char token[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[1];
	tokens[0] = token;
	LCTokenize(szArgs, tokens, 1, szExtra);
	CGroup *pGroup = GetGroupByName(tokens[0]);
	if (!pGroup)
	{
		BangFailed("SetTextColor", token);
		return;
	}
	pGroup->SetTextColor(utils::String2Color(szExtra));
}

void bangSetTextBkColor	(HWND caller, LPCSTR szArgs)
{
	char token[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[1];
	tokens[0] = token;
	LCTokenize(szArgs, tokens, 1, szExtra);
	CGroup *pGroup = GetGroupByName(tokens[0]);
	if (!pGroup)
	{
		BangFailed("SetTextBkColor", token);
		return;
	}
	pGroup->SetTextBkColor(utils::String2Color(szExtra));
}

void bangSetBackground	(HWND caller, LPCSTR szArgs)
{
	char
		token1[MAX_LINE_LENGTH],
		token2[MAX_LINE_LENGTH],
		token3[MAX_LINE_LENGTH],
		token4[MAX_LINE_LENGTH],
		token5[MAX_LINE_LENGTH],
		szExtra[MAX_LINE_LENGTH];
	char* tokens[5] = {token1, token2, token3, token4, token5};
	LCTokenize(szArgs, tokens, 5, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (!pGroup)
	{
		BangFailed("SetBackground", token1);
		return;
	}
	pGroup->SetBackground(token2, atoi(token3), atoi(token4), utils::String2Bool(token5));
}

void bangSetBackgroundColor	(HWND caller, LPCSTR szArgs)
{
	char token[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[1];
	tokens[0] = token;
	LCTokenize(szArgs, tokens, 1, szExtra);
	CGroup *pGroup = GetGroupByName(tokens[0]);
	if (!pGroup)
	{
		BangFailed("SetBackgroundColor", token);
		return;
	}
	pGroup->SetBackgroundColor(utils::String2Color(szExtra));
}


/*void bangHook	(HWND caller, LPCSTR szArgs)
{
	char token[MAX_LINE_LENGTH], extra[MAX_LINE_LENGTH];
	char* tokens[1];
	tokens[0] = token;
	LCTokenize(szArgs, tokens, 1, extra);
	CGroup *pGroup = GetGroupByName(tokens[0]);  <-- Here must be tokens[0] ;)
	if (!pGroup)
	{
		BangFailed("Hook", tokens[0]);  <-- Here must be tokens[0] ;)
		return;
	}

	char *handle = strrchr(szArgs, ' ');
	if (handle) 
	{
		HWND hBoxWnd = (HWND)atoi(handle+1);
		pGroup->Hook(hBoxWnd);
	}
}*/

void bangToggleExplorerDesktop	(HWND caller, LPCSTR szArgs)
{
	CGroup *pGroup = GetGroupByName(szArgs);
	if (pGroup)
		pGroup->ToggleExplorerDesktop();
	else
		BangFailed("ToggleExplorerDesktop", szArgs);
}

void bangExplorerDesktop (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->ExplorerDesktop(utils::String2Bool(token2));
	else
		BangFailed("ExplorerDesktop", token1);
}
void bangHotTracking (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->HotTracking(utils::String2Bool(token2));
	else
		BangFailed("HotTracking", token1);
}
void bangHotTrackingTime (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->HotTrackingTime(atoi(token2));
	else
		BangFailed("HotTrackingTime", token1);
	return;
}
void bangConfirmFileDelete (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->m_bConfirmFileDelete = utils::String2Bool(token2);
	else
		BangFailed("ConfirmFileDelete", token1);
}
void bangDontUseReycleBin (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->m_bDontUseRecycleBin = utils::String2Bool(token2);
	else
		BangFailed("DontUseReycleBin", token1);
}
void bangNoConnectedFiles (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->m_bNoConnectedFiles = utils::String2Bool(token2);
	else
		BangFailed("NoConnectedFiles", token1);
}
void bangSimpleProgress (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->m_bSimpleProgress = utils::String2Bool(token2);
	else
		BangFailed("SimpleProgress", token1);
}
void bangSnapToGrid (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->SnapToGrid(utils::String2Bool(token2));
	else
		BangFailed("SnapToGrid", token1);
}
void bangVirtualFileDelete (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->m_bVirtualFileDelete = utils::String2Bool(token2);
	else
		BangFailed("VirtualFileDelete", token1);
}
void bangUseDelete (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->m_bUseDelete = utils::String2Bool(token2);
	else
		BangFailed("UseDelete", token1);
}
void bangUseRename (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->m_bUseRename = utils::String2Bool(token2);
	else
		BangFailed("UseRename", token1);
}
void bangInlineBrowsing (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->m_bInlineBrowsing = utils::String2Bool(token2);
	else
		BangFailed("InlineBrowsing", token1);
}
void bangPasteFiles	(HWND caller, LPCSTR szArgs) {
	CGroup *pGroup = GetGroupByName(szArgs);
	if (pGroup)
		pGroup->PasteFiles();
	else
		BangFailed("PasteFiles", szArgs);
}
/*
void bangShowMyComputer (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->MyComputerShortcut(utils::String2Bool(token2));
	else
		BangFailed("ShowMyComputer", token1);
}
void bangShowMyNetworkPlaces (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->MyNetworkPlacesShortcut(utils::String2Bool(token2));
	else
		BangFailed("ShowMyNetworkPlaces", token1);
}
void bangShowInternetExplorer (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->IEShortcut(utils::String2Bool(token2));
	else
		BangFailed("ShowInternetExplorer", token1);
}
void bangShowMyDocuments (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->MyDocumentsShortcut(utils::String2Bool(token2));
	else
		BangFailed("ShowMyDocuments", token1);
}
void bangShowRecycleBin (HWND caller, LPCSTR szArgs) {
	char token1[MAX_LINE_LENGTH], token2[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[2] = {token1, token2};
	LCTokenize(szArgs, tokens, 2, szExtra);
	CGroup *pGroup = GetGroupByName(token1);
	if (pGroup)
		pGroup->RecycleBinShortcut(utils::String2Bool(token2));
	else
		BangFailed("ShowRecycleBin", token1);
}
*/
void bangChangeDir	(HWND caller, LPCSTR szArgs)
{
	char token[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[1];
	tokens[0] = token;
	LCTokenize(szArgs, tokens, 1, szExtra);
	CGroup *pGroup = GetGroupByName(tokens[0]);
	if (pGroup)
		pGroup->ChangeDir(szExtra);
	else
		BangFailed("ChangeDir", token);
}
void bangSetViewMode	(HWND caller, LPCSTR szArgs)
{
	char token[MAX_LINE_LENGTH], szExtra[MAX_LINE_LENGTH];
	char* tokens[1];
	tokens[0] = token;
	LCTokenize(szArgs, tokens, 1, szExtra);
	CGroup *pGroup = GetGroupByName(tokens[0]);
	if (pGroup)
		pGroup->SetViewMode(szExtra);
	else
		BangFailed("SetViewMode", token);
}